#include "game_state.h"
#include "macros.h"

GameState *GameState::singleton_instance{ nullptr };

void GameState::_bind_methods() {
	BIND_PROPERTY(Variant::STRING, locale_uid);
	BIND_PROPERTY(Variant::STRING, locale_entrance_path);
	{
		String const party_member_data_hint{ vformat("%s/%s:PartyMemberData", Variant::OBJECT, PROPERTY_HINT_RESOURCE_TYPE) };
		BIND_HPROPERTY(Variant::ARRAY, player_party, PROPERTY_HINT_ARRAY_TYPE, party_member_data_hint);
	}
}

GameState::GameState() {
	self_type::singleton_instance = this;
}

GameState::~GameState() {
	self_type::singleton_instance = nullptr;
}

GameState *GameState::get_singleton() {
	return self_type::singleton_instance;
}

void GameState::set_locale_uid(String const &value) {
	this->locale_uid = value;
}

String GameState::get_locale_uid() const {
	return this->locale_uid;
}

void GameState::set_locale_entrance_path(String const &value) {
	this->locale_uid = value;
}

String GameState::get_locale_entrance_path() const {
	return this->locale_uid;
}

void GameState::set_player_party(Array array) {
	this->player_party.clear();
	for (int i{ 0 }; i < array.size(); ++i) {
		Ref<PartyMemberData> data{ array[i] };
		if (data.is_valid()) {
			this->player_party.push_back(data);
		}
	}
}

Array GameState::get_player_party() const {
	Array a{};
	for (Ref<PartyMemberData> const &data : this->player_party) {
		a.push_back(data);
	}
	return a;
}
