#ifndef GAME_STATE_H
#define GAME_STATE_H

#include "authority/party_member_data.h"
#include "core/object/object.h"
#include "core/templates/vector.h"

class GameState : public Object {
	GDCLASS(GameState, Object);
	static void _bind_methods();
	static GameState *singleton_instance;

public:
	GameState();
	virtual ~GameState();
	static GameState *get_singleton();
	void set_locale_uid(String const &value);
	String get_locale_uid() const;
	void set_locale_entrance_path(String const &value);
	String get_locale_entrance_path() const;
	void set_player_party(Array array);
	Array get_player_party() const;

private:
	String locale_uid{ "" };
	String locale_entrance_path{ "" };
	Vector<Ref<PartyMemberData>> player_party{};
};

#endif // !GAME_STATE_H
