#ifndef PLAYER_INPUT_H
#define PLAYER_INPUT_H

#include "core/input/input_event.h"
#include "scene/main/node.h"

class PlayerInput : public Node {
	GDCLASS(PlayerInput, Node);
	static void _bind_methods();

public:
	void _notification(int what);
	virtual void unhandled_input(Ref<InputEvent> const &event) override;
	void set_action_move_left(String action);
	String get_action_move_left() const;
	void set_action_move_right(String action);
	String get_action_move_right() const;
	void set_action_move_forward(String action);
	String get_action_move_forward() const;
	void set_action_move_back(String action);
	String get_action_move_back() const;

public:
	static String const signal_movement;

private:
	String action_move_left{ "move_left" };
	String action_move_right{ "move_right" };
	String action_move_forward{ "move_forward" };
	String action_move_back{ "move_back" };
};

#endif // !PLAYER_INPUT_H
