#include "register_types.h"

#include "authority/actor_body.h"
#include "authority/game_state.h"
#include "authority/locale_marker.h"
#include "authority/party_member_data.h"
#include "authority/player_actor.h"
#include "authority/player_input.h"
#include "core/config/engine.h"
#include "core/object/class_db.h"

GameState *game_state{ nullptr };

void initialize_authority_module(ModuleInitializationLevel p_level) {
	if (p_level != MODULE_INITIALIZATION_LEVEL_SCENE) {
		return;
	}
	GDREGISTER_CLASS(GameState);
	GDREGISTER_RUNTIME_CLASS(LocaleMarker);
	GDREGISTER_RUNTIME_CLASS(PartyMemberData);
	GDREGISTER_CLASS(ActorBody);
	GDREGISTER_CLASS(PlayerActor);
	GDREGISTER_CLASS(PlayerInput);

	game_state = memnew(GameState);
	Engine::get_singleton()->add_singleton(Engine::Singleton("GameState", GameState::get_singleton()));
}

void uninitialize_authority_module(ModuleInitializationLevel p_level) {
	if (p_level != MODULE_INITIALIZATION_LEVEL_SCENE) {
		return;
	}
	if (game_state) {
		memdelete(game_state);
	}
}
